/*
 *
 * $Source: /filesv/usr/local/proj/sphinx/spx2/src/lib/auth/RCS/uid.c,v $
 *
 *
 *  MODULE NAME:    uid.c
 *
 *
 *  AUTHORS:
 *
 *      J. Tardo
 *
 */


/*
 * COPYRIGHT (C) 1992 DIGITAL EQUIPMENT CORPORATION
 * ALL RIGHTS RESERVED
 *
 * "Digital Equipment Corporation authorizes the reproduction,
 * distribution and modification of this software subject to the following
 * restrictions:
 * 
 * 1.  Any partial or whole copy of this software, or any modification
 * thereof, must include this copyright notice in its entirety.
 *
 * 2.  This software is supplied "as is" with no warranty of any kind,
 * expressed or implied, for any purpose, including any warranty of fitness 
 * or merchantibility.  DIGITAL assumes no responsibility for the use or
 * reliability of this software, nor promises to provide any form of 
 * support for it on any basis.
 *
 * 3.  Distribution of this software is authorized only if no profit or
 * remuneration of any kind is received in exchange for such distribution. 
 * 
 * 4.  This software and all application programs are to be used only for
 * non-commercial purposes. However, media costs associated with the
 * distribution of the software or application programs may be recovered.
 *
 */


#include <stdio.h>
#include <sys/time.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/timeb.h>

int generate_unique_identifier(uuid)
unsigned char * uuid ;  /* length assumed 16 bytes */
{
  struct timeb now;
  char ourname[40];
  struct hostent *us;

  if (gethostname(ourname, 40)) {
    fprintf(stderr, "generate_unique_identifier: gethostname error\n");
    return(-1);
  }
  memset(uuid,0,16);
  us = (struct hostent *)gethostbyname(ourname);
  ftime(&now);
  memcpy(uuid,&now,8);
  memcpy(uuid+8,"ARPA",4);
  if (us != 0) memcpy(uuid+12,us->h_addr,us->h_length);
  return(0);
}
